#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <ctype.h>
#include <time.h>
#include "tetX.h"
#include "egafont.h"
#include "keyjoy.h"
#include "kbcodes.h"

extern long Ticks;
extern int ScreenHeight, ScreenWidth;

extern int BoardX, BoardY, BoardW, BoardH;
extern int ScoreX, ScoreY, ScoreW, ScoreH;
extern int VgaVideoMode;
extern int NextX, NextY, NextW, NextH;
extern int JoyX,  JoyY,  JoyW, JoyH;
extern int FgrColour, BkgrColour, TxtColour, HiliteColour, ScrollColour;
extern int  Demo, JoyEnabled, MusicEnabled, ScrollAvailable;
extern unsigned int Score;
extern unsigned int  Scores[10];        // Scores for each level
extern int Statist[NFIGS];              // Number of figures
extern int StatLays[10];                // Layers for each level
extern int DefLevel, DefLays;           // Default level and number of layers
extern int ScrollX, ScrollY, ScrollW, ScrollH, ScrollVScale, ScrollHScale;
extern int ShadowY;
extern int ScrollEX, ScrollEY, ScrollEH;
extern int Level;
extern char *VarTexts[];

extern int BkgrPatColour[];
extern char FillPats[][8];
extern char *IntroText;
extern char *PlayListFileName;
extern char *ScoresFileName;
extern char *Player;

extern WHERE_WE_ARE  where;
extern BOTTOM_MODE   BottomMode;

static int  HighScorX=-1, HighScorY, HighScorW, HighScorH;
static int  AdviceX, AdviceY, AdviceW, AdviceH;
static int  SelectW, SelectD;
static int  HdrVscale, HdrHscale;

static int  SelCellW, SelCellH;
static int  CurWnd,   CurSel[2];

static int PressKeys[] = { JOY_BTN1, KY_ENTER, ' ', 'Q', 0};


void ShowRemark(void)
{
   static struct rem_struct
   { unsigned minscore;
     char *text;
   } Remarks[] =
    {
      {    0, "Looks like you accidentally pressed 'Q'"},
      { 1000, "Never mind, just play again" },
      { 4000, "That was not too bad"},
      { 7000, "Excellent for a beginner"},
      {11000, "Well done!"},
      {15000, "Fantastic rezult!"},
      {20000, "Incredible, you must be an extra-terrestrian"}
    };

#define LAST_REM_INDEX (sizeof(Remarks)/sizeof(struct rem_struct)-1)
   int w;

   RECT rc;
   int x, y, i;
   char *txt;

   if (Score == 0) return;

   // ! Starting index should be euqal to number of struct items - 2
   for(i=LAST_REM_INDEX; i>=0 && (Score < Remarks[i].minscore); i--);

   txt = Remarks[i].text;

   // Drawing frame
   rc.left = ScrollX; rc.right = ScrollX + ScrollW;

//   if (ScreenHeight > 350)
   {
      rc.top = ScrollY;  rc.bottom = ScrollY + ScrollH;
      DrawFramedRect(&rc);
   }
/*
   else
   {//  rc.left = x; rc.right = x+w;
      rc.top = ScrollEY;  rc.bottom = ScrollEY + ScrollEH;
//      DrawSolidRect(&rc, BkgrColour);
      DrawFramedRect(&rc);
   }
*/
   // Centering the text
   w = egaGetTextWidth(txt)*ScrollHScale;
   x  = (ScrollW - w) >> 1;
   x += ScrollX;
   y = ScrollEY;

   egaShowScaledText(txt, x, y, ScrollColour, BkgrColour, ScrollHScale, ScrollVScale);
}

int ShowStatistics(void)
{ FIGURE figure;
  char txt[122];
  char *tottxt = VarTexts[TotalTextPos];
  char tottxt1[7];

  int i, thrown;
  int StatX, StatY;
  int StatW, StatH;
  long total = 0;
  int  totlays;
  int  dist = ROW_DISTANCE*3;
  int x, x1, y, y1, h, fh, fw;
  RECT  rc;
  long  NextTicks;

 /*********************************************/
 /***************  Preparation  ***************/
 /*********************************************/



  where = W_RESULTS;
  PrepareMusic(0);

#ifdef X11
   if (BottomMode == B_SHADOW)
#else
   if (!Demo && BottomMode == B_SHADOW)
#endif
               ShowShadowFrame();

  AllocScreenContext();
  ScreenToScreenContext();

  HideBonus();

  // Clear 'Next' and 'Joystick' window
  rc.top = NextY - 10 - (BoardY%8);
  rc.bottom = JoyY + JoyH + 8;
  if (ScreenHeight <= 350) rc.bottom -= 3;
  rc.left = NextX - 8;
  rc.right = NextX + NextW + 8;
  DrawBkgrPattern(&rc);

 /*********************************************/
 /*****************  Figures ******************/
 /*********************************************/
 // Clear board
  rc.left = BoardX; rc.right = BoardX + BoardW;
  rc.top = BoardY; rc.bottom = BoardY + BoardH;
  DrawSolidRect(&rc, BkgrColour);

  fh = egaGetFontHeight();
  StatW = FIG_WIDTH*FIG_DIM + egaGetTextWidth(" 99999");
  // One figure has height 1, other have height 2
  StatH = fh + (FIG_HEIGHT*2+dist)*NFIGS - FIG_HEIGHT;
  StatX = BoardX + ((BoardW - StatW)>>1);
  StatY = BoardY + ((BoardH - StatH)>>1);

  y = StatY;
  for (i=0; i<NFIGS; i++)
   {
       get_figure (figure, i, 0);
       h = fig_height(figure);

#ifdef RIGHT_ADJUSTMENT
       x = StatX + StatW - fig_width(figure)*FIG_WIDTH;
#else
       x = StatX;
#endif
       ShowFigure(figure, x, y, FIG_DIM,  h);

       h *= FIG_HEIGHT;
       thrown = Statist[i];

       sprintf(txt, "%d", thrown);
#ifdef RIGHT_ADJUSTMENT
       x = StatX;
#else
       x = StatX + StatW - egaGetTextWidth(txt);
#endif
       if (i==0) y1 = y; else y1 = y + (FIG_HEIGHT/2);
       egaShowText(txt, x, y1, TxtColour, BkgrColour);
       total += thrown;
       y += h + dist;

   }

//   DrawPatLine(StatX, y -(dist>>1), StatW, 0x4E, TxtColour, BkgrColour);

   sprintf(txt, "%ld", total);

#ifdef RIGHT_ADJUSTMENT
   x = StatX + StatW - egaGetTextWidth(tottxt);
   x1 = StatX;
#else
   x = StatX;
   x1 = StatX + StatW - egaGetTextWidth(txt);
#endif


   egaShowText(tottxt, x, y, HiliteColour, BkgrColour);
   egaShowText(txt, x1, y, HiliteColour, BkgrColour);

 /*********************************************/
 /************  Scores by levels **************/
 /*********************************************/
    dist = ROW_DISTANCE;
    StatW = egaGetTextWidth(" 999999 9999 99999 ");
    if (StatW < ScoreW) StatW = ScoreW;
 //   StatX = ScoreX - ((StatW - ScoreW)>> 1);
//    StatX = ScoreX + ScoreW - StatW;
    StatX = ScrollX + ScrollW - StatW;
    StatX = StatX & 0xfff8;
    x = StatX + fw;
    y = 0;

    for (i=0; i<= Level; i++)
    {  if (Scores[i] > 0 || StatLays[i]>0) y++; }

    if (y==0) goto ByPass2;


    StatH = (y+1) * (fh + dist) + dist;
    StatY = BoardY + BoardH - StatH;


    rc.left = StatX; rc.right = StatX + StatW;
    rc.top = StatY; rc.bottom = StatY + StatH;
    DrawFramedRect(&rc);

    fw = egaGetTextWidth("0");
    x = StatX;
    y = StatY + dist;
    total = 0;
    totlays = 0;

    for (i=0; i<= Level; i++)
    {

       if (Scores[i] > 0 || StatLays[i]>0)
       {
#ifdef RIGHT_ADJUSTMENT
           sprintf(txt, "%5u %4d %6d",  Scores[i], StatLays[i], i);
#else
           sprintf(txt, " %2d    %4d %5u", i, StatLays[i], Scores[i]);
#endif

         egaShowText(txt, x+fw, y, TxtColour, BkgrColour);
         total += Scores[i];
         totlays += StatLays[i];
         y += fh + dist;
       }
    }

//   DrawPatLine(x+fw, y -(dist>>1), StatW-2*fw, 0x4E, TxtColour, BkgrColour);
    strncpy(tottxt1, VarTexts[TotalTextPos], 6);
    tottxt1[6] = '\0';

#ifdef RIGHT_ADJUSTMENT
    sprintf(txt, "%5lu %4d %6s",  total, totlays, tottxt1);
#else
    sprintf(txt, "%6s %4d %5lu", tottxt1, totlays, total);
#endif
    egaShowText(txt, x+fw, y, HiliteColour, BkgrColour);


ByPass2:
  if (!Demo) ShowRemark();
 // else
 // if (ScrollAvailable && ScreenHeight <= 350)
 //        ShowScrollerFrame();

  ScreenContextToScreen();
  DeleteScreenContext();

  NextTicks = Ticks + (Demo ? 91 : 182) ;        // Wait 5 seconds for demo
                                                 // 10 seconds otherwise
  while ((i=checkKeys(PressKeys)) < 0)
  {  if (Ticks > NextTicks)
                {i=-1; break;}
  }

//  if (i==3) return 4;    // Quit
  return 0;

}

/* ************************************************************** */
/*               Show top scorers and related stuff               */
/* ************************************************************** */

#define NUMHIST   10     // Max number of top scorers (was 10)


int ShowAdvice(int place, char name[31], int x, int y)
{  RECT rc;

   int x1, y1, k, n;
   static char Text1[] = "You are one of the TOPS SCORERS !!!     Congratulations";
   static char Text2[] = "Enter your name, or hit 'Esc' to discard.";
   static char Text3[] = "H U R R A A H !!!  You are number %.  Congratulations";
   char   tmp[3] = {0, 0};
   static char *pos = NULL;

   where = W_ADVICE;
   PrepareMusic(0);

   rc.left = AdviceX;
   rc.right = AdviceX + AdviceW;
   rc.top = AdviceY;
   rc.bottom = AdviceY + AdviceH;

   DrawFramedRect(&rc);
   rc.left -= 8; rc.right += 8;
   rc.top -= 8;  rc.bottom += 8;

   x1 = AdviceX + 8;
   y1 = AdviceY + 8;

   if (place < 3)
   {  if (!pos) pos = strchr(Text3, '%');
      *pos = place + '1';
      egaShowScaledText(Text3, x1, y1, HiliteColour, BkgrColour, 1, 2);
   }
   else
      egaShowScaledText(Text1, x1, y1, HiliteColour, BkgrColour, 1, 2);

   y1 += egaGetFontHeight() * 2 + 2;
   egaShowText(Text2, x1, y1, TxtColour, BkgrColour);

   ScreenContextToScreen();
   DeleteScreenContext();

   y1 = y;
   n = strlen(name);
#ifdef TOP_SCORES_RIGHT_ADJUSTMENT
   x += 27*8;
   x1 = x + (20-n)*8;
#else
   x1 = n*8 + x;
#endif
   egaShowText("_", x1, y1, HiliteColour, BkgrColour);
   while(1)
   {
     k = kbdGet();
     if (k== KY_ESC) { n = 0; break;}
     else
     if (k==KY_ENTER) break;
     else
     if (k==KY_BACK || k==KY_DELETE)
     {
       if (n > 0)
       {  name[--n] = '\0';
 #ifdef TOP_SCORES_RIGHT_ADJUSTMENT
          x1 += 8;
          egaShowText(" _", x1-8, y1, HiliteColour, BkgrColour);
#else
          x1 -= 8;
          egaShowText("_ ", x1, y1, HiliteColour, BkgrColour);
#endif
       }
       else
       {  putchar('\a');
          fflush(stdout);
       }
     }
     else
     if (k > 0)
     {
        if (n<30)
       { tmp[0] = k;
          name[n++] = k;
          name[n] = '\n';
 #ifdef TOP_SCORES_RIGHT_ADJUSTMENT
          egaShowText(tmp, x1, y1, HiliteColour, BkgrColour);
          if (n<30) egaShowText("_", x1-8, y1, HiliteColour, BkgrColour);
          x1 -= 8;
#else
          egaShowText(tmp, x1, y1, HiliteColour, BkgrColour);
          if (n<30) egaShowText("_", x1+8, y1, HiliteColour, BkgrColour);
          x1 += 8;
#endif
        }
        else
        {  putchar('\a');
           fflush(stdout);
        }
     }  // else
   }  // while

   name[n] = '\0';

   AllocScreenContext();
   ScreenToScreenContext();
   return  ( n > 0);
}


static void ShowErrorFrame(int which)
{
   RECT rc;
   int x, y, hei;
   char *ErrorArr0[] = {
        "Wrong or incompatible structure of High Scores file",
	"       %s",
	"",
        "This can be a result of using incompatible C-library",
	"(e.g. libc5 against glibc).", 
	"The game will continue without high scores.", 
	"",
	"In order to create an adequate file, remove or rename",
	"the existing file. The file will be created next time",
	"when you run the game with appropriate access.",
	NULL} ; 

   char *ErrorArr1[] = {
        "Could not open or create High Scores file:",
        "       %s",
        "The game will continue without high scores.",
	"",
        "Run the application once as root in order to create it,",
	"or if file exists, set access by", 
        "       chmod 666 %s",
	"",
	"If you don't have a root access, consider changing",
	"location of High Scores file by setting SCOREDIR",
	"parameter in Makefile and recompiling.",
	 NULL };

   char **ErrArrPtr[] = {ErrorArr0, ErrorArr1};    
   char **WhichErrLineset, *WhichErrLine;
   char buf[81];

   rc.top = HighScorY;
   rc.left = HighScorX;
   rc.right = HighScorX + HighScorW;
   rc.bottom = HighScorY + HighScorH;

   hei = egaGetFontHeight();
   x = HighScorX + 12;
   y =  HighScorY + 2*(hei+ROW_DISTANCE);

   DrawFramedRect(&rc);
   WhichErrLineset = ErrArrPtr[which];
   
   while ((WhichErrLine = *WhichErrLineset++) != NULL)
   {  if (strstr(WhichErrLine, "%s"))
      { sprintf (buf, WhichErrLine, ScoresFileName);  
        egaShowText(buf, x, y, HiliteColour, BkgrColour);
      }
      else
        egaShowText(WhichErrLine, x, y, TxtColour, BkgrColour);
      y += hei;
   }          
	   	
}

#define CURRENT_VERSION_NUMBER 0x20
int ShowScorers(void)
{
  int  len, numhis, i, j, k, lev;
  int x, y, hei;
  int my_y;
  int fd=-1,  seed;
  unsigned int scor;
  int  vernum;
  int  write_flag = 0;
  long dat;

  RECT rc;

  char buf[81];
  unsigned int  HiScores[NUMHIST];
  int  HiLevels[NUMHIST];
  char HiNames[NUMHIST][31];
  long HiDates[NUMHIST];

  static char *Signature = "ACE Intelligent TETRIS. High scores";
  static char *NamMon[12] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun",
                             "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};

   char *Header = VarTexts[TopHeaderPos];


   while(kbdGet()!=0); 


   k = 0; my_y = -1;


   fd = open(ScoresFileName, O_RDWR);

   if (fd >= 0)
   { // Get ver number;
     vernum = 0;	
     if(read(fd, &vernum, sizeof(vernum)) == 0)
			     goto OtraVista;    

     if (vernum != CURRENT_VERSION_NUMBER)	   
                             goto DoneReading;
			
     len = strlen(Signature);

     read(fd, buf, len);
     if (memcmp(buf, Signature, len) != 0)
                             goto DoneReading;

     if (read (fd, &seed, sizeof(seed)) != sizeof(seed))
                             goto OtraVista;
	
     seed = ~seed;
     srand(seed);

     if (read (fd, &numhis, sizeof(numhis)) != sizeof(numhis))
                             goto DoneReading;
     numhis = rand()-numhis;
     if (numhis <=0 || numhis > NUMHIST) goto DoneReading;

     for (i=0; i<numhis; i++)
     { if (read(fd, &scor, sizeof(scor)) != sizeof(scor))
                                     goto DoneReading;
       scor = rand() - scor;

       if (Score > 0 && scor < Score && my_y < 0)
       { my_y = k;
         k++;
         write_flag = 1;
       }

       if (k >= NUMHIST)
       { i = numhis; break; }

       HiScores[k] = scor;

       if (read (fd, &lev, sizeof(lev)) != sizeof(lev))
                                    goto DoneReading;
       HiLevels[k] = rand() - lev;

       if (read(fd, &dat, sizeof(dat)) != sizeof(dat))
                                   goto DoneReading;

       HiDates[k] = ((long)rand() << 5) - dat;

       if (read(fd, &len, sizeof(len)) != sizeof(len))
                                   goto DoneReading;
       len = rand() - len;
       read(fd, buf, len);

       for (j = 0; j<len ; j++)
          buf[j] = rand() - buf[j];

       buf[len] = 0;

       strcpy(HiNames[k], buf);

       k++;
     }

DoneReading:
     if (k==0 || i<numhis)
     {
	ShowErrorFrame(0);
	my_y = -1; k = 0;
	goto ToExit;	
     }		
     
   }

OtraVista:
   if (fd < 0 || k <= 0 )
   {  if (fd < 0)
        fd = creat(ScoresFileName, 0666);

      HiDates[0] = 13021998l;
      strcpy (HiNames[0], "A.C.E.");
      HiLevels[0] = 7;
      HiScores[0] = 12000;

      HiDates[1] = 20111993l;
      strcpy (HiNames[1], "Abandoned Softwarers");
      HiLevels[1] = 5;
      HiScores[1] = 10000;
      k = 2;
      write_flag = 1;
   }

   if (fd < 0)
   {
	ShowErrorFrame(1);
	my_y = -1; k = 0;
	goto ToExit;
   }    	

   if (Score > 0 && my_y < 0 && k < NUMHIST-1)
   {   my_y = k;
       write_flag = 1;
       k++;
   }

   numhis = k;


   if(my_y >= 0)
   {
       // These structures are defined locally and die
       // with the exit from the block
       time_t  RawTime;
       struct  tm  *BrokenTime;

       RawTime = time(NULL);

       BrokenTime = localtime(&RawTime);

       strcpy(HiNames[my_y], Player ? Player: "");

       HiScores[my_y] = Score;
       HiLevels[my_y] = Level;
       HiDates[my_y] = BrokenTime->tm_mday * 1000000l
                     + BrokenTime->tm_mon * 10000l
                     + BrokenTime->tm_year + 1900;

   }

   // Clear Scoreboard


   rc.top = HighScorY;
   rc.left = HighScorX;
   rc.right = HighScorX + HighScorW;
   rc.bottom = HighScorY + HighScorH;

   DrawFramedRect(&rc);

   y = HighScorY + 1;
   k = egaGetTextWidth(Header) * HdrHscale;
   x = ((HighScorW - k) >> 1) + HighScorX;
   egaShowScaledText(Header, x, y, HiliteColour, BkgrColour,
                            HdrHscale, HdrVscale);

   hei = egaGetFontHeight();
   y += HdrVscale*hei + ROW_DISTANCE;

   x = HighScorX+16;
   hei += ROW_DISTANCE;

  //  Print the scores at last
   for (i=0; i < numhis; i++)
   {
     dat = HiDates[i];
     j = (int)(dat / 1000000l);
     dat = dat % 1000000l;
 #ifdef TOP_SCORES_RIGHT_ADJUSTMENT
 {  char buffer[31];
    char *n = HiNames[i];
    int ii, l;

    l = strlen(n);

    for (ii=0; ii<l; ii++) buffer[29-ii] = n[ii];
    for (; ii<30; ii++) buffer[29-ii] = ' ';
    buffer[30] = '\0';


    sprintf(buf, "%5u %3d %02d-%s-%02d %30s .%u" ,
                   HiScores[i], HiLevels[i],
                   j, NamMon[(int)(dat/10000)], (int)(dat % 10000),
                   buffer, i+1);
 }
#else
    sprintf(buf, "%2d. %-30s %02d-%s-%02d %3d %5u" ,
                   i+1,  HiNames[i],
                   j, NamMon[(int)(dat/10000)], (int)(dat % 10000),
                   HiLevels[i], HiScores[i]);
#endif

    egaShowText(buf, x, y, (i==my_y) ? HiliteColour : TxtColour, BkgrColour);
    if (i==my_y) k = y;
    y += hei;
   }


   if (my_y >= 0)
   {  if (!ShowAdvice(my_y, HiNames[my_y], x+32, k))
             write_flag = 0;
   }

   where = W_BETWEEN;
   PrepareMusic(0);

   if (write_flag)
   {
     lseek(fd, 0, SEEK_SET);
     vernum = CURRENT_VERSION_NUMBER;	
     write(fd, &vernum, sizeof(vernum));    // write Ver Number
     write(fd, Signature, strlen(Signature)); // write signature

     seed = time(0);
     i = ~seed;
     write (fd, &i, sizeof(seed));

     srand(seed);
     i = rand()-numhis;
     write (fd, &i, sizeof(numhis));

     for (i=0; i<numhis; i++)
     { scor = rand() - HiScores[i];
       write(fd, &scor, sizeof(scor));

       lev = rand() - HiLevels[i];
       write(fd, &lev, sizeof(lev));

       dat = ((long)rand() << 5) - HiDates[i];
       write (fd, &dat, sizeof(dat));


       strcpy(buf, HiNames[i]);
       len = strlen(buf);

       j = rand() - len;
       write(fd, &j, sizeof(len));

       for (j = 0; j<len ; j++)
          buf[j] = (char) (rand() - buf[j]);


       write (fd, &buf, len);

     }

   }

 ToExit:
   Score = 0;
   if (fd>=0)  close(fd);
   return (my_y >= 0) ? 1: 0;
}

//------------------------------------------------------------------
#define SEL_HSCALE  1
#define SEL_VSCALE  2

static void ShowSelCell(int wnd, int cell)
{   int x, y;
    unsigned long  fg, bg;
    RECT rc;

     x = AdviceX + SelCellW * (cell%5);
     if (wnd) x+= SelectD;

     y = AdviceY;
     if (cell >=5) y += (SelCellH + 1);

     if(cell == CurSel[wnd])
     {
        bg = FgrColour;
        bg = (CurWnd == wnd) ? HiliteColour : FgrColour;
        fg =  BkgrColour;
     }
     else
     {  bg = BkgrColour;
        fg = FgrColour;
     }

     rc.left = x+1; rc.right = x + SelCellW;
     rc.top = y;  rc.bottom = y + SelCellH;
     if (cell >= 5) rc.bottom -= 2;
     DrawSolidRect(&rc, bg);
     egaShowCharSpecial(cell+'0', x+(SelCellW/3), y, fg, bg,
                       SEL_HSCALE, SEL_VSCALE, 0);

}

#define TickDelay 4
static int ObtainSelection(void)
{   int key;
    int oldsel;
    int oldwnd;
    int update;
    int quit = 0;
    long CurTim;
    long NextTicks = Ticks;
	
    do
    {   CurTim = Ticks;
        if (JoyEnabled && CurTim >= NextTicks)
               key = getKeyJoy();
        else
               key = kbdGet();

        if (key < 0x100) key = toupper(key);

        oldsel = CurSel[CurWnd];
        oldwnd = CurWnd;
        update = 1;


        switch(key)
        {  case JOY_DOWN:
           case KY_DOWN:
           case '2':
                if (oldsel < 5) CurSel[CurWnd] = oldsel + 5;
              break;

           case JOY_UP:
           case KY_UP:
           case '8':
                if (oldsel >= 5) CurSel[CurWnd] = oldsel - 5;
                break;

           case JOY_RIGHT:
           case KY_RIGHT:
           case '6':
                CurSel[CurWnd] = (oldsel + 1) % 10;
                break;

           case JOY_LEFT:
           case KY_LEFT:
           case '4':
                CurSel[CurWnd] = (oldsel == 0) ? 9 : (oldsel - 1);
                break;

           case KY_TAB:
           case JOY_BTN1:
                CurWnd = 1 - oldwnd;
                break;

           case KY_SPACE:
           case 'D':
                Demo = 1;
                quit = 1;
                update = 0;
                break;

           case KY_ENTER:
           case JOY_BTN2:
                Demo = 0;
                quit = 1;
                update = 0;
                break;

	     case 'J':
		    EnableJoystick();
		    NextTicks = CurTim + TickDelay;
		    break;			

	     case 'K':
		    DisableJoystick();
		    break;			

           case 'M':
                if (PlayListFileName)
                { MusicEnabled = !MusicEnabled;
                  PrepareMusic(0);
                }
                break;

           case 'Q':
           case KY_BACK:
           case KY_DELETE:
           case KY_ESC:
                quit = 5;
                                     // No break here
           default:
                update = 0;
         }


         if (update)
         { ShowSelCell(oldwnd, oldsel);
           ShowSelCell(CurWnd, CurSel[CurWnd]);
   /*      if (oldwnd == 0 && CurWnd == 0 )
               PlayPlayLine((int)CurSel[CurWnd], MODE_FORCE);
   */
           if (key>=JOY_START) NextTicks = CurTim + TickDelay;
         }


    } while (quit==0);

    return (quit-1);
}

void ShowKeys(void)
{    RECT   rect;
     int    x, y, w, h, w1;
     char   *Header = "Command keys";
     char   **ptr;

     char   *LeftList[]  = {"Tab JoyB1", "Levels-Layers",
                            "Ent JoyB2", "Normal game",
                            "Spc   D  ", "Demo game",
                            "Esc   Q  ", "Quit" };


     w = SelectD - SelectW - 64;
     rect.top = AdviceY;
     rect.left = AdviceX + SelectW + 32;
     rect.bottom = AdviceY + AdviceH;
     rect.right = rect.left + w;

     DrawFramedRect(&rect);

     w1 = egaGetTextWidth(Header);
     x = rect.left + ((w - w1) >> 1);
     h = egaGetFontHeight();
     y = AdviceY - h - 2;
     egaShowText(Header, x, y, FgrColour, BkgrColour);

     x = rect.left + 8;
     y = rect.top + 1;


     w = egaGetTextWidth("Ent JoyB1  ");
     ptr = LeftList;

     for (w1=0; w1<4; w1++)
     {  egaShowText(*ptr++, x, y, HiliteColour, BkgrColour);
        egaShowText(*ptr++, x+w,  y, TxtColour, BkgrColour);
        y += h;
     }
}




void ShowSelection(void)
{    RECT  rc;
     int   x, x1, y, y1;
     int   i;

     char TempTxt[31];

     rc.top = AdviceY-8;
     rc.left = AdviceX-8;
     rc.bottom = AdviceY + AdviceH+8;
     rc.right = AdviceX + AdviceW+8;
     DrawPatRect(&rc, FillPats[14], 0);   // Was 10


     rc.top = AdviceY;
     rc.left = AdviceX;
     rc.bottom = AdviceY + AdviceH;
     rc.right = AdviceX + SelectW;
     DrawFramedRect(&rc);

     strcpy(TempTxt, VarTexts[LevelTextPos]);

#ifdef RIGHT_ADJUSTMENT
     if (*TempTxt==':') strcpy(TempTxt, TempTxt+1);
#else
     x1 = strlen(TempTxt) -1;
     if (TempTxt[x1]==':') TempTxt[x1] = '\0';
#endif

     x1 = egaGetTextWidth(TempTxt);
     x = AdviceX + ((SelectW - x1) >> 1);
     y = AdviceY - egaGetFontHeight() - 2;
     egaShowText(TempTxt, x, y, FgrColour, BkgrColour);



     rc.left += SelectD;
     rc.right += SelectD;
     DrawFramedRect(&rc);

     strcpy(TempTxt, VarTexts[LayersTextPos]);

#ifdef RIGHT_ADJUSTMENT
     if (*TempTxt==':') strcpy(TempTxt, TempTxt+1);
#else
     x1 = strlen(TempTxt) -1;
     if (TempTxt[x1]==':') TempTxt[x1] = '\0';
#endif

     x1 = egaGetTextWidth(TempTxt);
     x = AdviceX +SelectD + ((SelectW - x1) >> 1);
     y = AdviceY - egaGetFontHeight() - 2;
     egaShowText(TempTxt, x, y, FgrColour, BkgrColour);


    ShowKeys();

     x = AdviceX + SelCellW;
//     vga_setcolor(FgrColour);
     y1 = AdviceY + AdviceH;
     for (i=0; i<4; i++)
     {  DrawSolidLine(x, AdviceY, x, y1, 1, FgrColour);
        x1 = x + SelectD;
        DrawSolidLine(x1, AdviceY, x1, y1, 1, FgrColour);
        x += SelCellW;
     }

     y  = AdviceY + SelCellH;
     x = AdviceX-1;
     x1 = AdviceX + SelectW;
//     vga_drawline(x, y, x1, y);
     DrawSolidLine(x, y, x1, y, 1, FgrColour);

     x += SelectD;
     x1 += SelectD;
//     vga_drawline(x, y, x1, y);
     DrawSolidLine(x, y, x1, y, 1, FgrColour);

     CurWnd = 0;
     CurSel[0] = DefLevel;
     CurSel[1] = DefLays;

     for (i=0; i<10; i++)
     {  ShowSelCell(0, i);
        ShowSelCell(1, i);
     }

}


int InitIntergameScreen(void)
{    int fh = egaGetFontHeight();

     AdviceW = 480;   //    ScreenWidth * 3/4;
     AdviceX = (ScreenWidth - AdviceW) >> 1;

     if (ScreenHeight > 350)  AdviceY = BoardY - 8;
                     else     AdviceY = BoardY + 20;

     HdrHscale = 2;
     HdrVscale = ScreenHeight > 350 ? 3 : 2;

     HighScorX = AdviceX;
     HighScorW = AdviceW;
     HighScorH = NUMHIST*(fh+ROW_DISTANCE)+
                    HdrVscale*fh + 4;
     HighScorY = BoardY + BoardH - HighScorH + 16;
   //if (ScreenHeight > 350) HighScorY += 4;

     SelCellW = egaGetTextWidth("0")*SEL_HSCALE*5/2+1;
     SelectW = SelCellW*5;
     SelCellH = SEL_VSCALE*(egaGetFontHeight() + 1);
     AdviceH = SelCellH *2 - 1;
     SelectD = AdviceW - SelectW*2 + SelectW;

     fh = ScreenWidth - (ScoreX + ScoreW);
     fh = ScreenWidth - (fh << 1);
     if (ScreenWidth < 640) fh+=12;
     SetScrollerParam(fh);

     if (ScreenHeight <= 350) ScrollY = ShadowY;
     else
     {  ScrollY = (ScreenHeight+BoardY+BoardH-ScrollH) >> 1;
//        if (ScreenHeight < 480) ScrollY -= 2;
     }

     ScrollEY = ScrollY + ((ScrollH-ScrollEH) >> 1);

     return 0;
}


int ShowIntergameScreen(void)
{    RECT rc;
     int retval;

     AllocScreenContext();

     rc.top = 0; rc.bottom = ScreenHeight;
     rc.left = 0; rc.right = ScreenWidth;

     where = W_BETWEEN;

     // Fill the background
     FgrColour = BkgrPatColour[10];
     DrawPatRect(&rc, FillPats[14], 0);

     if (Demo) Score = 0;
     retval = ShowScorers();
     if (retval < 0) return 8;
     if (retval > 0) ShowScorers(); 

     ScreenContextToScreen();
     DeleteScreenContext();

     ShowSelection();

     PrepareMusic(0);

     retval = ObtainSelection();

     DefLevel = CurSel[0];
     DefLays = CurSel[1];

     return retval;
}

